## linux-rpi 6.12.34

=== security/lockdown/Makefile ===
obj-$(CONFIG_SECURITY_LOCKDOWN_LSM) += lockdown.o

=== tools/virtio/Makefile ===
# SPDX-License-Identifier: GPL-2.0
all: test mod
test: virtio_test vringh_test vhost_net_test
virtio_test: virtio_ring.o virtio_test.o
vringh_test: vringh_test.o vringh.o virtio_ring.o
vhost_net_test: virtio_ring.o vhost_net_test.o

try-run = $(shell set -e;		\
	if ($(1)) >/dev/null 2>&1;	\
	then echo "$(2)";		\
	else echo "$(3)";		\
	fi)

__cc-option = $(call try-run,\
	$(1) -Werror $(2) -c -x c /dev/null -o /dev/null,$(2),)
cc-option = $(call __cc-option, $(CC),$(1))

CFLAGS += -g -O2 -Werror -Wno-maybe-uninitialized -Wall -I. -I../include/ -I ../../usr/include/ -Wno-pointer-sign -fno-strict-overflow -fno-strict-aliasing -fno-common -MMD -U_FORTIFY_SOURCE -include ../../include/linux/kconfig.h $(call cc-option,-mfunction-return=thunk) $(call cc-option,-fcf-protection=none) $(call cc-option,-mindirect-branch-register)

CFLAGS += -pthread
LDFLAGS += -pthread
vpath %.c ../../drivers/virtio ../../drivers/vhost
mod:
	${MAKE} -C `pwd`/../.. M=`pwd`/vhost_test V=${V}

#oot: build vhost as an out of tree module for a distro kernel
#no effort is taken to make it actually build or work, but tends to mostly work
#if the distro kernel is very close to upstream
#unsupported! this is a development tool only, don't use the
#resulting modules in production!
OOT_KSRC=/lib/modules/$$(uname -r)/build
OOT_VHOST=`pwd`/../../drivers/vhost
#Everyone depends on vhost
#Tweak the below to enable more modules
OOT_CONFIGS=\
	CONFIG_VHOST=m \
	CONFIG_VHOST_NET=n \
	CONFIG_VHOST_SCSI=n \
	CONFIG_VHOST_VSOCK=n \
	CONFIG_VHOST_RING=n
OOT_BUILD=KCFLAGS="-I "${OOT_VHOST} ${MAKE} -C ${OOT_KSRC} V=${V}
oot-build:
	echo "UNSUPPORTED! Don't use the resulting modules in production!"
	${OOT_BUILD} M=`pwd`/vhost_test
	${OOT_BUILD} M=${OOT_VHOST} ${OOT_CONFIGS}

oot-clean: oot-build
oot: oot-build
oot-clean: OOT_BUILD+=clean

.PHONY: all test mod clean vhost oot oot-clean oot-build
clean:
	${RM} *.o vringh_test virtio_test vhost_net_test vhost_test/*.o \
              vhost_test/.*.cmd vhost_test/Module.symvers \
              vhost_test/modules.order *.d
-include *.d

=== arch/arm/mach-npcm/Makefile ===
# SPDX-License-Identifier: GPL-2.0-only
obj-$(CONFIG_ARCH_WPCM450)	+= wpcm450.o
obj-$(CONFIG_ARCH_NPCM7XX)	+= npcm7xx.o
obj-$(CONFIG_SMP)		+= platsmp.o headsmp.o

=== drivers/iio/dac/Makefile ===
# SPDX-License-Identifier: GPL-2.0
#
# Makefile for industrial I/O DAC drivers
#

# When adding new entries keep the list in alphabetical order
obj-$(CONFIG_AD3552R) += ad3552r.o
obj-$(CONFIG_AD5360) += ad5360.o
obj-$(CONFIG_AD5380) += ad5380.o
obj-$(CONFIG_AD5421) += ad5421.o
obj-$(CONFIG_AD5624R_SPI) += ad5624r_spi.o
obj-$(CONFIG_AD5064) += ad5064.o
obj-$(CONFIG_AD5504) += ad5504.o
obj-$(CONFIG_AD5446) += ad5446.o
obj-$(CONFIG_AD5449) += ad5449.o
obj-$(CONFIG_AD5592R_BASE) += ad5592r-base.o
obj-$(CONFIG_AD5592R) += ad5592r.o
obj-$(CONFIG_AD5593R) += ad5593r.o
obj-$(CONFIG_AD5755) += ad5755.o
obj-$(CONFIG_AD5758) += ad5758.o
obj-$(CONFIG_AD5761) += ad5761.o
obj-$(CONFIG_AD5764) += ad5764.o
obj-$(CONFIG_AD5766) += ad5766.o
obj-$(CONFIG_AD5770R) += ad5770r.o
obj-$(CONFIG_AD5791) += ad5791.o
obj-$(CONFIG_AD5686) += ad5686.o
obj-$(CONFIG_AD5686_SPI) += ad5686-spi.o
obj-$(CONFIG_AD5696_I2C) += ad5696-i2c.o
obj-$(CONFIG_AD7293) += ad7293.o
obj-$(CONFIG_AD7303) += ad7303.o
obj-$(CONFIG_AD8801) += ad8801.o
obj-$(CONFIG_AD9739A) += ad9739a.o
obj-$(CONFIG_ADI_AXI_DAC) += adi-axi-dac.o
obj-$(CONFIG_CIO_DAC) += cio-dac.o
obj-$(CONFIG_DPOT_DAC) += dpot-dac.o
obj-$(CONFIG_DS4424) += ds4424.o
obj-$(CONFIG_LPC18XX_DAC) += lpc18xx_dac.o
obj-$(CONFIG_LTC1660) += ltc1660.o
obj-$(CONFIG_LTC2632) += ltc2632.o
obj-$(CONFIG_LTC2664) += ltc2664.o
obj-$(CONFIG_LTC2688) += ltc2688.o
obj-$(CONFIG_M62332) += m62332.o
obj-$(CONFIG_MAX517) += max517.o
obj-$(CONFIG_MAX5522) += max5522.o
obj-$(CONFIG_MAX5821) += max5821.o
obj-$(CONFIG_MCP4725) += mcp4725.o
obj-$(CONFIG_MCP4728) += mcp4728.o
obj-$(CONFIG_MCP4821) += mcp4821.o
obj-$(CONFIG_MCP4922) += mcp4922.o
obj-$(CONFIG_STM32_DAC_CORE) += stm32-dac-core.o
obj-$(CONFIG_STM32_DAC) += stm32-dac.o
obj-$(CONFIG_TI_DAC082S085) += ti-dac082s085.o
obj-$(CONFIG_TI_DAC5571) += ti-dac5571.o
obj-$(CONFIG_TI_DAC7311) += ti-dac7311.o
obj-$(CONFIG_TI_DAC7612) += ti-dac7612.o
obj-$(CONFIG_VF610_DAC) += vf610_dac.o

=== lib/math/tests/Makefile ===
# SPDX-License-Identifier: GPL-2.0-only

obj-$(CONFIG_INT_POW_TEST) += int_pow_kunit.o

=== drivers/media/platform/aspeed/Makefile ===
# SPDX-License-Identifier: GPL-2.0-only
obj-$(CONFIG_VIDEO_ASPEED) += aspeed-video.o

=== drivers/net/wan/framer/Makefile ===
# SPDX-License-Identifier: GPL-2.0
#
# Makefile for the framer drivers.
#

obj-$(CONFIG_GENERIC_FRAMER)			+= framer-core.o
obj-$(CONFIG_FRAMER_PEF2256)			+= pef2256/

=== drivers/net/wireless/broadcom/brcm80211/brcmsmac/Makefile ===
#
# Makefile fragment for Broadcom 802.11n Networking Device Driver
#
# Copyright (c) 2010 Broadcom Corporation
#
# Permission to use, copy, modify, and/or distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
# SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
# OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
# CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

ccflags-y := \
	-I $(src) \
	-I $(src)/phy \
	-I $(src)/../include

brcmsmac-y := \
	mac80211_if.o \
	ucode_loader.o \
	ampdu.o \
	antsel.o \
	channel.o \
	main.o \
	phy_shim.o \
	pmu.o \
	rate.o \
	stf.o \
	aiutils.o \
	phy/phy_cmn.o \
	phy/phy_lcn.o \
	phy/phy_n.o \
	phy/phytbl_lcn.o \
	phy/phytbl_n.o \
	phy/phy_qmath.o \
	dma.o \
	brcms_trace_events.o \
	debug.o

brcmsmac-$(CONFIG_BRCMSMAC_LEDS) += led.o

obj-$(CONFIG_BRCMSMAC)	+= brcmsmac.o

=== debian/changelog ===
linux-rpi (1:6.12.34-1+rpt1+0kali2) kali-dev; urgency=medium

  * Prepare for Release
  * Update rpi patch

 -- Steev Klimaszewski <steev@kali.org>  Mon, 21 Jul 2025 10:53:54 -0500

linux-rpi (1:6.12.34-1+rpt1+0kali1) kali-dev; urgency=medium

  [ Serge Schneider ]
  * Raspberry Pi OS release
  * Add v8-rt kernel support
  * Update Raspberry Pi patch
  * Update debian/config
  * Linux commit: 8f77e03530f65209a377d25023e912b288e039cd

 -- Steev Klimaszewski <steev@kali.org>  Tue, 15 Jul 2025 20:22:35 -0500

linux (1:6.12.25-1+rpt1) bookworm; urgency=medium

  * Raspberry Pi OS release
  * Update Raspberry Pi patch
  * Update debian/config
  * Linux commit: 3dd2c2c507c271d411fab2e82a2b3b7e0b6d3f16

 -- Serge Schneider <serge@raspberrypi.com>  Wed, 30 Apr 2025 13:45:17 +0100

linux (1:6.12.20-1+rpt1~bpo12+1) bookworm; urgency=medium

  * Raspberry Pi OS release
  * d/control: Update Maintainer, Homepage and Vcs information
  * Remove unnecessary patches
  * Disable unnecessary architectures
  * Don't sign arm64 kernels
  * Compress arm64 kernels
  * Add epoch support in version string
  * Allow initramfs generation to be skipped in postinst
  * Add rpi featureset
  * Install overlays README
  * Add +rpt to abiname
  * Add update helper script
  * Refresh gitignore.patch
  * Linux commit: cd231d4775b14f228606c09f219b48308f6ab3aa

 -- Serge Schneider <serge@raspberrypi.com>  Wed, 19 Mar 2025 16:49:28 +0000

linux-rpi (1:6.12.20-1+rpt1+0kali1) kali-dev; urgency=medium

  * Update with Kali patches
  * Update Maintainer field
  * Update Vcs-* fields
  * Update for Kali Packaging
  * Mark packages arch specific and remove binary-indep
  * Update lintian-overrides
  * Update for Kali Packaging
  * Add back linux-kbuild package
  * Update for Kali Packaging
  * Make headers-common an all architecture package again
  * Update for Kali Packaging
  * Only run build-arch on supported arches
  * Update for Kali Packaging
  * Update rules to only build on supported arches
  * Update for Kali Packaging
  * Revert "Mark packages arch specific and remove binary-indep"
  * Update for Kali Packaging
  * Disable CI builds
  * Make config package architecture specific
  * Update for Kali Packaging
  * d/patches: Update wifi injection patch

 -- Steev Klimaszewski <steev@kali.org>  Tue, 15 Apr 2025 13:10:03 -0500

linux-rpi (1:6.12.20-1+rpt1) bookworm; urgency=medium

  * Raspberry Pi OS release
  * d/control: Update Maintainer, Homepage and Vcs information
  * Remove unnecessary patches
  * Disable unnecessary architectures
  * Don't sign arm64 kernels
  * Compress arm64 kernels
  * Add epoch support in version string
  * Allow initramfs generation to be skipped in postinst
  * Add rpi featureset
  * Install overlays README
  * Add +rpt to abiname
  * Add update helper script
  * Refresh gitignore.patch
  * Linux commit: cd231d4775b14f228606c09f219b48308f6ab3aa

 -- Serge Schneider <serge@raspberrypi.com>  Wed, 19 Mar 2025 16:49:28 +0000

linux (6.12.9-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports:
    - d/salsa-ci.yml: Set RELEASE to bookworm-backports
    - Revert compiler version to gcc-12
    - debian_linux.config_v2: Add workaround for a bug in older dacite

 -- Ben Hutchings <benh@debian.org>  Mon, 20 Jan 2025 00:46:37 +0100

linux (6.12.9-1) unstable; urgency=medium

  * New upstream stable update:
    https://www.kernel.org/pub/linux/kernel/v6.x/ChangeLog-6.12.9
    - [x86] platform/x86: mlx-platform: call pci_dev_put() to balance the
      refcount
    - drm/amdgpu: fix backport of commit 73dae652dcac (Closes: #1092187)
    - [x86] platform/x86: thinkpad-acpi: Add support for hotkey 0x1401
    - [x86] platform/x86: hp-wmi: mark 8A15 board for timed OMEN thermal profile
    - selinux: ignore unknown extended permissions
    - mmc: sdhci-msm: fix crypto key eviction
    - [arm64,armhf] pmdomain: imx: gpcv2: fix an OF node reference leak in
      imx_gpcv2_probe()
    - pmdomain: core: add dummy release function to genpd device
    - tracing: Have process_string() also allow arrays
    - block: lift bio_is_zone_append to bio.h
    - btrfs: use bio_is_zone_append() in the completion handler
    - RDMA/bnxt_re: Remove always true dattr validity check
    - sched_ext: fix application of sizeof to pointer
    - RDMA/mlx5: Enforce same type port association for multiport RoCE
    - RDMA/bnxt_re: Fix max SGEs for the Work Request
    - RDMA/bnxt_re: Avoid initializing the software queue for user queues
    - RDMA/bnxt_re: Avoid sending the modify QP workaround for latest adapters
    - RDMA/core: Fix ENODEV error for iWARP test over vlan
    - nvme-pci: 512 byte aligned dma pool segment quirk
    - wifi: iwlwifi: fix CRF name for Bz
    - RDMA/bnxt_re: Fix the check for 9060 condition
    - RDMA/bnxt_re: Add check for path mtu in modify_qp
    - RDMA/bnxt_re: Fix reporting hw_ver in query_device
    - RDMA/nldev: Set error code in rdma_nl_notify_event
    - RDMA/siw: Remove direct link to net_device
    - RDMA/bnxt_re: Fix max_qp_wrs reported
    - RDMA/bnxt_re: Disable use of reserved wqes
    - RDMA/bnxt_re: Add send queue size check for variable wqe
    - RDMA/bnxt_re: Fix MSN table size for variable wqe mode
    - RDMA/bnxt_re: Fix the locking while accessing the QP table
    - net: phy: micrel: Dynamically control external clock of KSZ PHY
    - [arm64] drm/bridge: adv7511_audio: Update Audio InfoFrame properly
    - netdev-genl: avoid empty messages in napi get
    - [arm64] RDMA/hns: Fix mapping error of zero-hop WQE buffer
    - [arm64] RDMA/hns: Fix accessing invalid dip_ctx during destroying QP
    - [arm64] RDMA/hns: Fix warning storm caused by invalid input in IO path
    - [arm64] RDMA/hns: Fix missing flush CQE for DWQE
    - drm/xe: Revert some changes that break a mesa debug tool
    - drm/xe/pf: Use correct function to check LMEM provisioning
    - drm/xe: Fix fault on fd close after unbind


=== debian/control ===
Source: linux-rpi
Section: kernel
Priority: optional
Maintainer: Serge Schneider <serge@raspberrypi.com>
Standards-Version: 4.2.0
Build-Depends: debhelper-compat (= 13), python3:native, python3-dacite:native, python3-jinja2:native, quilt, dh-python <!pkg.linux.notools>
Build-Depends-Arch: bc <!pkg.linux.nokernel>, libssl-dev:native <!pkg.linux.nokernel>, libssl-dev <!pkg.linux.notools>, openssl <!pkg.linux.nokernel>, libelf-dev:native <!pkg.linux.nokernel>, libelf-dev <!pkg.linux.notools>, lz4 [amd64 arm64] <!pkg.linux.nokernel>, pahole <!pkg.linux.nokernel> | dwarves:native (>= 1.16~) <!pkg.linux.nokernel>, cpio <!pkg.linux.nokernel>, xz-utils <!pkg.linux.nokernel>, bison <!pkg.linux.nokernel>, bison <!pkg.linux.notools>, flex <!pkg.linux.nokernel>, flex <!pkg.linux.notools>, gcc-12 [arm64 armel armhf] <!cross !pkg.linux.nokernel>, gcc-12-aarch64-linux-gnu [arm64] <cross !pkg.linux.nokernel>, gcc-arm-linux-gnueabihf [arm64] <!pkg.linux.nokernel>, gcc-12-arm-linux-gnueabi [armel] <cross !pkg.linux.nokernel>, gcc-12-arm-linux-gnueabihf [armhf] <cross !pkg.linux.nokernel>, rsync [arm64 armel armhf] <!pkg.linux.nokernel !pkg.linux.quick>, kernel-wedge (>= 2.105~) [arm64 armel armhf] <!pkg.linux.nokernel !pkg.linux.quick>, kmod [arm64 armel armhf] <!pkg.linux.nokernel !pkg.linux.quick>
Build-Depends-Indep: patchutils <!pkg.linux.nosource !pkg.linux.quick>, xz-utils <!pkg.linux.nosource !pkg.linux.quick>
Rules-Requires-Root: no
Homepage: https://github.com/raspberrypi/linux/
Vcs-Browser: https://github.com/RPi-Distro/linux-packaging/
Vcs-Git: https://github.com/RPi-Distro/linux-packaging.git

Package: linux-headers-6.12.34+rpt-common-rpi
Architecture: all
Build-Profiles: <!pkg.linux.nokernel>
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Common header files for Linux 6.12.34+rpt-rpi
 This package provides the common kernel header files for Linux kernel
 version 6.12.34+rpt with the Raspberry Pi featureset, generally used for
 building out-of-tree kernel modules.  These files are going to be
 installed into /usr/src/linux-headers-6.12.34+rpt-common-rpi.
 .
 To obtain a complete set of headers you also need to install the
 linux-headers-6.12.34+rpt-(flavour) package, matching the flavour of the
 kernel you intend the build for.

Package: linux-headers-6.12.34+rpt-rpi-2712
Architecture: arm64
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.quick>
Depends: linux-headers-6.12.34+rpt-common-rpi (= ${source:Version}), linux-image-6.12.34+rpt-rpi-2712 (= ${binary:Version}) | linux-image-6.12.34+rpt-rpi-2712-unsigned (= ${binary:Version}), linux-kbuild-6.12.34+rpt, ${misc:Depends}, gcc-12
Description: Header files for Linux 6.12.34+rpt-rpi-2712
 This package provides the architecture-specific kernel header files for
 Linux kernel 6.12.34+rpt-rpi-2712, generally used for building out-of-tree
 kernel modules.  These files are going to be installed into
 /usr/src/linux-headers-6.12.34+rpt-rpi-2712, and can be used for building
 modules that load into the kernel provided by the
 linux-image-6.12.34+rpt-rpi-2712 package.

Package: linux-headers-6.12.34+rpt-rpi-v6
Architecture: armel
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.quick>
Depends: linux-headers-6.12.34+rpt-common-rpi (= ${source:Version}), linux-image-6.12.34+rpt-rpi-v6 (= ${binary:Version}) | linux-image-6.12.34+rpt-rpi-v6-unsigned (= ${binary:Version}), linux-kbuild-6.12.34+rpt, ${misc:Depends}, gcc-12
Description: Header files for Linux 6.12.34+rpt-rpi-v6
 This package provides the architecture-specific kernel header files for
 Linux kernel 6.12.34+rpt-rpi-v6, generally used for building out-of-tree
 kernel modules.  These files are going to be installed into
 /usr/src/linux-headers-6.12.34+rpt-rpi-v6, and can be used for building
 modules that load into the kernel provided by the
 linux-image-6.12.34+rpt-rpi-v6 package.

Package: linux-headers-6.12.34+rpt-rpi-v7
Architecture: armhf
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.quick>
Depends: linux-headers-6.12.34+rpt-common-rpi (= ${source:Version}), linux-image-6.12.34+rpt-rpi-v7 (= ${binary:Version}) | linux-image-6.12.34+rpt-rpi-v7-unsigned (= ${binary:Version}), linux-kbuild-6.12.34+rpt, ${misc:Depends}, gcc-12
Description: Header files for Linux 6.12.34+rpt-rpi-v7
 This package provides the architecture-specific kernel header files for
 Linux kernel 6.12.34+rpt-rpi-v7, generally used for building out-of-tree
 kernel modules.  These files are going to be installed into
 /usr/src/linux-headers-6.12.34+rpt-rpi-v7, and can be used for building
 modules that load into the kernel provided by the
 linux-image-6.12.34+rpt-rpi-v7 package.

Package: linux-headers-6.12.34+rpt-rpi-v7l
Architecture: armhf
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.quick>
Depends: linux-headers-6.12.34+rpt-common-rpi (= ${source:Version}), linux-image-6.12.34+rpt-rpi-v7l (= ${binary:Version}) | linux-image-6.12.34+rpt-rpi-v7l-unsigned (= ${binary:Version}), linux-kbuild-6.12.34+rpt, ${misc:Depends}, gcc-12
Description: Header files for Linux 6.12.34+rpt-rpi-v7l
 This package provides the architecture-specific kernel header files for
 Linux kernel 6.12.34+rpt-rpi-v7l, generally used for building out-of-tree
 kernel modules.  These files are going to be installed into
 /usr/src/linux-headers-6.12.34+rpt-rpi-v7l, and can be used for building
 modules that load into the kernel provided by the
 linux-image-6.12.34+rpt-rpi-v7l package.

Package: linux-headers-6.12.34+rpt-rpi-v8
Architecture: arm64
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.quick>
Depends: linux-headers-6.12.34+rpt-common-rpi (= ${source:Version}), linux-image-6.12.34+rpt-rpi-v8 (= ${binary:Version}) | linux-image-6.12.34+rpt-rpi-v8-unsigned (= ${binary:Version}), linux-kbuild-6.12.34+rpt, ${misc:Depends}, gcc-12
Description: Header files for Linux 6.12.34+rpt-rpi-v8
 This package provides the architecture-specific kernel header files for
 Linux kernel 6.12.34+rpt-rpi-v8, generally used for building out-of-tree
 kernel modules.  These files are going to be installed into
 /usr/src/linux-headers-6.12.34+rpt-rpi-v8, and can be used for building
 modules that load into the kernel provided by the
 linux-image-6.12.34+rpt-rpi-v8 package.

Package: linux-headers-rpi-2712
Architecture: arm64
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.nometa !pkg.linux.quick>
Depends: linux-headers-6.12.34+rpt-rpi-2712 (= ${binary:Version}), ${misc:Depends}
Description: Header files for Linux rpi-2712 configuration (meta-package)
 This package depends on the architecture-specific header files for the
 latest Linux kernel rpi-2712 configuration.

Package: linux-headers-rpi-v6
Architecture: armel
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.nometa !pkg.linux.quick>
Depends: linux-headers-6.12.34+rpt-rpi-v6 (= ${binary:Version}), ${misc:Depends}
Description: Header files for Linux rpi-v6 configuration (meta-package)
 This package depends on the architecture-specific header files for the
 latest Linux kernel rpi-v6 configuration.

Package: linux-headers-rpi-v7
Architecture: armhf
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.nometa !pkg.linux.quick>
Depends: linux-headers-6.12.34+rpt-rpi-v7 (= ${binary:Version}), ${misc:Depends}
Description: Header files for Linux rpi-v7 configuration (meta-package)
 This package depends on the architecture-specific header files for the
 latest Linux kernel rpi-v7 configuration.

Package: linux-headers-rpi-v7l
Architecture: armhf
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.nometa !pkg.linux.quick>
Depends: linux-headers-6.12.34+rpt-rpi-v7l (= ${binary:Version}), ${misc:Depends}
Description: Header files for Linux rpi-v7l configuration (meta-package)
 This package depends on the architecture-specific header files for the
 latest Linux kernel rpi-v7l configuration.

Package: linux-headers-rpi-v8
Architecture: arm64
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.nometa !pkg.linux.quick>
Depends: linux-headers-6.12.34+rpt-rpi-v8 (= ${binary:Version}), ${misc:Depends}
Description: Header files for Linux rpi-v8 configuration (meta-package)
 This package depends on the architecture-specific header files for the
 latest Linux kernel rpi-v8 configuration.

Package: linux-image-6.12.34+rpt-rpi-2712
Architecture: arm64
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.quick>
Depends: kmod, linux-base (>= 4.3~), ${misc:Depends}, initramfs-tools (>= 0.120+deb8u2) [arm64] | linux-initramfs-tool [arm64]
Recommends: apparmor [arm64]
Suggests: firmware-linux-free, linux-doc-6.12, debian-kernel-handbook
Breaks: fwupdate (<< 12-7) [arm64], wireless-regdb (<< 2019.06.03-1~) [arm64], initramfs-tools (<< 0.120+deb8u2) [arm64]
Description: Linux 6.12 for Raspberry Pi 2712, Raspberry Pi
 The Linux kernel 6.12 and modules for use on Raspberry Pi 2712 kernel.
 .
 This kernel includes the patches for Raspberry Pi platforms.

Package: linux-image-6.12.34+rpt-rpi-2712-dbg
Architecture: arm64
Section: debug
Priority: optional
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.nokerneldbg !pkg.linux.quick>
Depends: ${misc:Depends}
Description: Debug symbols for linux-image-6.12.34+rpt-rpi-2712
 This package provides the detached debug symbols for the Linux kernel and
 modules in linux-image-6.12.34+rpt-rpi-2712.

Package: linux-image-6.12.34+rpt-rpi-v6
Architecture: armel
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.quick>
Depends: kmod, linux-base (>= 4.3~), ${misc:Depends}, initramfs-tools (>= 0.120+deb8u2) [armel] | linux-initramfs-tool [armel]
Recommends: apparmor [armel]
Suggests: firmware-linux-free, linux-doc-6.12, debian-kernel-handbook
Breaks: fwupdate (<< 12-7) [armel], wireless-regdb (<< 2019.06.03-1~) [armel], initramfs-tools (<< 0.120+deb8u2) [armel]
Description: Linux 6.12 for Rasbperry Pi v6, Raspberry Pi
 The Linux kernel 6.12 and modules for use on Raspberry Pi v6 kernel.
 .
 This kernel includes the patches for Raspberry Pi platforms.

Package: linux-image-6.12.34+rpt-rpi-v6-dbg
Architecture: armel
Section: debug
Priority: optional
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.nokerneldbg !pkg.linux.quick>
Depends: ${misc:Depends}
Description: Debug symbols for linux-image-6.12.34+rpt-rpi-v6
 This package provides the detached debug symbols for the Linux kernel and
 modules in linux-image-6.12.34+rpt-rpi-v6.

Package: linux-image-6.12.34+rpt-rpi-v7
Architecture: armhf
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.quick>
Depends: kmod, linux-base (>= 4.3~), ${misc:Depends}, initramfs-tools (>= 0.120+deb8u2) [armhf] | linux-initramfs-tool [armhf]
Recommends: apparmor [armhf]
Suggests: firmware-linux-free, linux-doc-6.12, debian-kernel-handbook
Breaks: fwupdate (<< 12-7) [armhf], wireless-regdb (<< 2019.06.03-1~) [armhf], initramfs-tools (<< 0.120+deb8u2) [armhf]
Description: Linux 6.12 for Raspberry Pi v7, Raspberry Pi
 The Linux kernel 6.12 and modules for use on Raspberry Pi v7 kernel.
 .
 This kernel includes the patches for Raspberry Pi platforms.

Package: linux-image-6.12.34+rpt-rpi-v7-dbg
Architecture: armhf
Section: debug
Priority: optional
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.nokerneldbg !pkg.linux.quick>
Depends: ${misc:Depends}
Description: Debug symbols for linux-image-6.12.34+rpt-rpi-v7
 This package provides the detached debug symbols for the Linux kernel and
 modules in linux-image-6.12.34+rpt-rpi-v7.

Package: linux-image-6.12.34+rpt-rpi-v7l
Architecture: armhf
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.quick>
Depends: kmod, linux-base (>= 4.3~), ${misc:Depends}, initramfs-tools (>= 0.120+deb8u2) [armhf] | linux-initramfs-tool [armhf]
Recommends: apparmor [armhf]
Suggests: firmware-linux-free, linux-doc-6.12, debian-kernel-handbook
Breaks: fwupdate (<< 12-7) [armhf], wireless-regdb (<< 2019.06.03-1~) [armhf], initramfs-tools (<< 0.120+deb8u2) [armhf]
Description: Linux 6.12 for Raspberry Pi v7, Raspberry Pi
 The Linux kernel 6.12 and modules for use on Raspberry Pi v7l kernel.
 .
 This kernel includes the patches for Raspberry Pi platforms.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

DEB_VERSION_SOURCE = $(shell echo '$(DEB_VERSION)' | sed -re 's/\+b([0-9]+)$$//')

SHELL    := sh -e

include debian/rules.defs

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  DEBIAN_KERNEL_JOBS := $(subst parallel=,,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif
ifdef DEBIAN_KERNEL_JOBS
  MAKEFLAGS += -j$(DEBIAN_KERNEL_JOBS)
endif

# dpkg-buildpackage passes the -s option if DEB_BUILD_OPTIONS contains
# terse, but that triggers Kbuild to turn off progress messages
# completely, which we don't want.
override MAKEFLAGS := $(subst s,,$(filter-out -%,$(MAKEFLAGS))) $(filter -%,$(MAKEFLAGS))

.NOTPARALLEL:

source: debian/control
	dh_testdir
	$(MAKE) -f debian/rules.gen source

setup: debian/control
	dh_testdir
	$(MAKE) -f debian/rules.gen setup_$(DEB_HOST_ARCH)

ifneq ($(filter arm64 armhf armel,${DEB_HOST_ARCH}),)
build: build-arch build-indep
else
build: build-indep
endif

build-arch: debian/control
	dh_testdir

# The perf-read-vdso* programs are built for different architectures,
# without standard flags, but are not exposed to untrusted input.
	@printf '%s\n' 'blhc: ignore-line-regexp: .* -o *[^ ]*/perf-read-vdso.*'

# Kernel code needs different hardening options that blhc doesn't know
# about.
	@printf '%s\n' 'blhc: ignore-line-regexp: .* -D__KERNEL__ .*'

# The tools/perf/tests/workloads/.* programs are deliberately compiled
# without -O2, so instruct blhc to ignore those
	@printf '%s\n' 'blhc: ignore-line-regexp: .* -o .*tools/perf/tests/workloads/.*'

# fixdep is not always built with the right flags but is also not packaged
	@printf '%s\n' 'blhc: ignore-line-regexp: .* -o .*/tools/.*/fixdep.*'

# We need to use terse builds in CI due to the log size limit.  This
# mostly affects the output for builds of kernel code, which need
# different options for hardening anyway.
ifneq ($(filter terse,$(DEB_BUILD_OPTIONS)),)
	@printf '%s\n' 'blhc: ignore-line-regexp: \s*(CC(LD)?|LD|LINK)\b.*'
endif

	$(MAKE) -f debian/rules.gen build-arch_$(DEB_HOST_ARCH)

build-indep: debian/control
	dh_testdir
	$(MAKE) -f debian/rules.gen build-indep

ifneq ($(filter arm64 armhf armel,${DEB_HOST_ARCH}),)
binary:	binary-indep binary-arch
else
binary: binary-indep
endif

binary-arch: build-arch
	dh_testdir
	$(MAKE) -f debian/rules.gen binary-arch_$(DEB_HOST_ARCH)

binary-indep: build-indep
	dh_testdir
	$(MAKE) -f debian/rules.gen binary-indep

DIR_ORIG = ../orig/$(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)
TAR_ORIG = ../$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig.tar.xz

orig: $(DIR_ORIG)
	rsync --delete --exclude /debian --exclude .git --link-dest=$(DIR_ORIG)/ -a $(DIR_ORIG)/ .
	QUILT_PATCHES='$(CURDIR)/debian/patches' QUILT_PC=.pc quilt push --quiltrc - -a -q --fuzz=0

$(DIR_ORIG): $(TAR_ORIG)
	mkdir -p ../orig
	tar -C ../orig -xaf $(TAR_ORIG)

CLEAN_PATTERNS := $(BUILD_DIR) $(STAMPS_DIR) debian/lib/python/debian_linux/*.pyc debian/lib/python/debian_linux/__pycache__ $$(find debian -maxdepth 1 -type d -name 'linux-*') debian/*-modules-*-di* debian/kernel-image-*-di* debian/*-tmp debian/*.substvars

clean-generated:
	rm -rf $(CLEAN_PATTERNS)
# We cannot use dh_clean here because it requires debian/control to exist
	rm -rf debian/.debhelper debian/*.debhelper* debian/files debian/generated.*
	rm -f \
		debian/control \
		debian/control.md5sum \
		debian/linux-doc.maintscript \
		debian/linux-headers-*.maintscript \
		debian/linux-headers-*.postinst \
		debian/linux-image-*.NEWS \
		debian/linux-image-*.bug-presubj \
		debian/linux-image-*.lintian-overrides \
		debian/linux-image-*.maintscript \
		debian/linux-image-*.postinst \
		debian/linux-image-*.postrm \
		debian/linux-image-*.preinst \
		debian/linux-image-*.prerm \
		debian/linux-source.maintscript \
		debian/rules.gen \
		debian/tests/control

maintainerclean: clean-generated
	rm -rf $(filter-out debian .git, $(wildcard * .[^.]*))

clean: debian/control
	dh_testdir
	rm -rf $(CLEAN_PATTERNS)
	dh_clean

CONTROL_FILES = $(BUILD_DIR)/version-info $(wildcard debian/templates/*.in)
CONTROL_FILES += debian/config/defines.toml $(wildcard debian/config/*/defines.toml)
CONTROL_FILES += debian/installer/package-list

# debian/bin/gencontrol.py uses debian/changelog as input, but the
# output only depends on the source name and version.  To avoid
# frequent changes to debian/control.md5sum, include only those fields
# in the checksum.
$(BUILD_DIR)/version-info: debian/changelog
	mkdir -p $(@D)
# Use DEB_VERSION_SOURCE to allow binNMU
	printf >$@ 'Source: %s\nVersion: %s\n' $(DEB_SOURCE) $(DEB_VERSION)

debian/control debian/rules.gen: debian/bin/gencontrol.py $(CONTROL_FILES)
ifeq ($(wildcard debian/control.md5sum),)
	$(MAKE) -f debian/rules debian/control-real
else
	md5sum --check debian/control.md5sum --status || \
		$(MAKE) -f debian/rules debian/control-real
endif

debian/control-real: debian/bin/gencontrol.py $(CONTROL_FILES)
# Hash randomisation makes the pickled config unreproducible
	PYTHONHASHSEED=0 $<
	md5sum $(sort $^) > debian/control.md5sum
	@echo
	@echo This target is made to fail intentionally, to make sure
	@echo that it is NEVER run during the automated build. Please
	@echo ignore the following error, the debian/control file has
	@echo been generated SUCCESSFULLY.
	@echo
	exit 1

.PHONY: binary binary-% build build-% clean debian/control-real orig setup source clean-generated

=== debian/tests/control ===
Test-Command: py.test debian/lib/python
Restrictions: superficial
Depends: python3-pytest, python3-jinja2

Test-Command: debian/tests/headers-kbuild 6.12.34+rpt-rpi-v8
Architecture: arm64
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-rpi-v8
Depends: linux-headers-6.12.34+rpt-rpi-v8, linux-image-6.12.34+rpt-rpi-v8

Test-Command: debian/tests/headers-kbuild 6.12.34+rpt-rpi-2712
Architecture: arm64
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-rpi-2712
Depends: linux-headers-6.12.34+rpt-rpi-2712, linux-image-6.12.34+rpt-rpi-2712

Test-Command: debian/tests/headers-kbuild 6.12.34+rpt-rpi-v6
Architecture: armel
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-rpi-v6
Depends: linux-headers-6.12.34+rpt-rpi-v6, linux-image-6.12.34+rpt-rpi-v6

Test-Command: debian/tests/headers-kbuild 6.12.34+rpt-rpi-v7
Architecture: armhf
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-rpi-v7
Depends: linux-headers-6.12.34+rpt-rpi-v7, linux-image-6.12.34+rpt-rpi-v7

Test-Command: debian/tests/headers-kbuild 6.12.34+rpt-rpi-v7l
Architecture: armhf
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-rpi-v7l
Depends: linux-headers-6.12.34+rpt-rpi-v7l, linux-image-6.12.34+rpt-rpi-v7l
